#include "convolution.h"


//     .
void convolve(const cufftComplex * a, const cufftComplex * b, int n, cufftComplex * result)
{
    //    .
    for (int i = 0; i < n; ++i)
    {
        result[i].x = 0;
        result[i].y = 0;
        //  result[i] = sum(a[j] * b[i - j], 0 <= j <= n - 1),
        //   : b[-k] = b[n - k].
        for (int j = 0; j < n; ++j)
        {
            int idx = ((j <= i) ? (i - j) : (n + i - j)); //  
            result[i].x += a[j].x * b[idx].x - a[j].y * b[idx].y;
            result[i].y += a[j].x * b[idx].y + a[j].y * b[idx].x;
        }
    }
}
